%if 0%{?fedora} || 0%{?rhel} == 6
%global with_unit_test 1
%else
%global with_unit_test 0
%endif

%global debug_package   %{nil}

%global provider        launchpad
%global tld             net
%global project         go-xdg
%global series          v0
%global import_path     %{provider}.%{tld}/%{project}/%{series}
%global snapshot        20151107

Name:           golang-launchpad-go-xdg-v0
Version:        0
Release:        0.2.%{snapshot}bzr%{?dist}
Summary:        Go library to use the XDG spec
License:        BSD
URL:            https://%{import_path}

# Source generated with these commands:
#  bzr branch lp:go-xdg/v0; cd v0
#  bzr export ~/rpmbuild/SOURCES/%%{name}-%%{snapshot}.tar.gz
Source0:        %{name}-%{snapshot}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}


%description
%{summary}.


%package devel
Summary:       %{summary}
BuildArch:     noarch
Provides:      golang(%{import_path}) = %{version}-%{release}


%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.


%if 0%{?with_unit_test}
%package unit-test
Summary:         Unit tests for %{name} package
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
BuildRequires:  golang(launchpad.net/gocheck)

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}
Requires:        golang(launchpad.net/gocheck)

%description unit-test
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{name}-%{snapshot}

%build

%install
# source codes for building projects
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done

# testing files for this project
%if 0%{?with_unit_test}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
%endif

sort -u -o devel.file-list devel.file-list

%check
%if 0%{?with_unit_test}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}

%if ! 0%{?gotest:1}
%global gotest go test
%endif

%gotest %{import_path}
%endif

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files devel -f devel.file-list
%license LICENSE
%doc README.md
%dir %{gopath}/src/%{provider}.%{tld}
%dir %{gopath}/src/%{provider}.%{tld}/%{project}
%dir %{gopath}/src/%{import_path}

%if 0%{?with_unit_test}
%files unit-test -f unit-test.file-list
%license LICENSE
%doc README.md
%endif


%changelog
* Mon Dec 14 2015 Adam Goode <adam@spicenitz.org> - 0-0.2.20151107bzr
- Remove most gofed-style macros to fix empty RHEL 7 packages

* Sun Dec  6 2015 Adam Goode <adam@spicenitz.org> - 0-0.1.20151107bzr
- Initial Fedora release.
